#include <stdio.h>
#include "shm.h"

#define SHMKEY 8101
#define SEMKEY 911

#define COUNT 10000

int main(int argc, char *argv[]) {

  char *counter;		/* shared memory */
  int num;			/* local copy */
  int i;			/* loop index */
  int incr;			/* increment or decrement */
  int sem;			/* semaphore */
  char input[80];
  key_t key = SHMKEY;

  /* parse command line */
  if (argc != 2) {
    printf("usage: %s <num>\n", argv[0]);
    exit(1);
  }
  incr = atoi(argv[1]);
  printf("increment: %d\n", incr);

  /* create the semaphore */
  if ((sem = screate(SEMKEY, 1)) < 0) {
    perror("screate");
    exit(1);
  }

  /* create or link to the shared memory counter */
  /* we need 6 digits plus a null */
  if ((counter = (char *) shmcreate(key, 6*sizeof(char))) == NULL) {
    perror("shmcreate");
    exit(1);
  }

  /* hack to initialize the shared memory */
  sscanf(counter, "%d", &num);
  if ((incr > 0) || (num < -1 * COUNT || num > COUNT)) 
    sprintf(counter, "0");

  for (i=0; i<COUNT; i++) {

    semwait(sem);

    /** begin critical region **/
  
    /* get old value */
    sscanf(counter, "%d", &num);
    num = num + incr;
    sprintf(counter, "%d\n", num);
    printf("%d\n", num);

    /** end critical region **/

    semsignal(sem);

  }

  /* remove the shared memory */
  shmdelete(counter);
  sdelete(sem);

  exit(0);

}
